/*
  CPP_CONTEST=2016
  CPP_PROBLEM=A
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=jupiter 1
*/

// 1

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    

using namespace std;

void escribirsubmatrix(int n,int m,int ld,double *a){
  int i, j;

  for (i = 0; i < n; i++)
  {
    for (j = 0; j < m; j++)
    {  
      cout << setiosflags(ios::fixed) << setprecision(4) <<a[i*ld+j]<<" ";
    }
    cout <<endl;
  }
  cout <<endl;
}

void copymatrix(int n,int m,double *o,double *d)
{
  int i;

  for(i=0;i<n*m;i++)
  {
    d[i]=o[i];
  }
}

double sumsubmatrix(int n,int m,int ld,double *a)
{
  double s=0.;
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<m;j++)
    {
      s+=a[i*ld+j];
    }
  }
  return s;
}

void scalevector(int n,double a,double *b,double *c)
{
  for(int i=0;i<n;i++)
    c[i]+=(a*b[i]);
}

void multiplyvectordiagonalbymatrix(int n,int m,int ld,double *a,double*b,double *c)
{
  for(int i=0;i<n;i++)
  {
     scalevector(m,a[i*ld],&b[i*m],&c[i*m]);
  }
}

void  sec(int N,double *A,double *B,double *C)
{
  for(int i=0;i<N;i++)
  {
     if(A[i]!=0.)
     {
        multiplyvectordiagonalbymatrix(N-i,N,N+1,&A[i],&B[N*i],C);
     } 
  }
  for(int i=1;i<N;i++)
  {
     if(A[i*N]!=0.)
     {
        multiplyvectordiagonalbymatrix(N-i,N,N+1,&A[i*N],B,&C[N*i]);
     } 
  }
}

