/*
  CPP_CONTEST=2016
  CPP_PROBLEM=F
  CPP_LANG=CPP+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 1
*/

// 1

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    

using namespace std;

//used for debugging, to write the sucessive boards
extern void escribir(int,int *);

int update(int n,int row, int column,int *a)
{
   int *pos=&a[row*n+column]; //address of the value to be updated
   int count=1;
   int value=pos[0];

//add value to the left
//from column 2 up, a maximum of two positions are considered
   if(column>=2)
   {
      if(pos[-1]!=0)
      {
         value+=pos[-1];
      }
      else if(pos[-2]!=0)
      {
         value+=pos[-2];
      }
      count++;
   } 
   else if(column==1)
   {
      if(pos[-1]!=0)
      {
         value+=pos[-1];
      }
      count++;
   }
//add value to the right
   if(column<=n-3)
   {
      if(pos[1]!=0)
      {
         value+=pos[1];
      }
      else if(pos[2]!=0)
      {
         value+=pos[2];
      }
      count++;
   } 
   else if(column==n-2)
   {
      if(pos[1]!=0)
      {
         value+=pos[1];
      }
      count++;
   }        
//add value up
   if(row>=2)
   {
      if(pos[-n]!=0)
      {
         value+=pos[-n];
      }
      else if(pos[-2*n]!=0)
      {
         value+=pos[-2*n];
      }
      count++;
   } 
   else if(row==1)
   {
      if(pos[-n]!=0)
      {
         value+=pos[-n];
      }
      count++;
   }   
//add value below
   if(row<=n-3)
   {
      if(pos[n]!=0)
      {
         value+=pos[n];
      }
      else if(pos[2*n]!=0)
      {
         value+=pos[2*n];
      }
      count++;
   } 
   else if(row==n-2)
   {
      if(pos[n]!=0)
      {
         value+=pos[n];
      }
      count++;
   }      
   return value/count;
}

int iteration(int n,int **a,int **b)
{
  int *da=*a,*db=*b; //to work directely with the boards, not with their addresses
  int *temp; //to swap the boards
  int num1=0;
  for(int i=0;i<n;i++)
  {
     for(int j=0;j<n;j++)
     {
         if(da[i*n+j]!=0)
         {
            db[i*n+j]=update(n,i,j,da);
            if(db[i*n+j]==1)
              num1++;
         }
         else
         {
            db[i*n+j]=0;
         }
     }
  }
  temp=*a;
  *a=*b;
  *b=temp;
  return num1;
}

void  sec(int n,int *a,int ni,int *num1,int np,int node)
{
  int *b=new int[n*n]; //auxiliar board
  for(int i=0;i<ni;i++)
  {
//the addresses of the boards are given as parameters, to work in an iteration from a to b and in the following from b to a
     num1[i]=iteration(n,&a,&b);
#ifdef DEBUG
// While debugging the matrix is written
      escribir(n,a);
      cout <<"number of 1: "<<num1[i]<<endl;
#endif
  }
}

